'''
Created on 19.09.2010

@author: Andre Netzeband

I have taken some code from the masterticket-plugin. 
'''

from trac.core import *
from trac.env import IEnvironmentSetupParticipant
from trac.web.chrome import ITemplateProvider
from trac.db import DatabaseManager
import db_default


#from trac.web.chrome import INavigationContributor, ITemplateProvider, add_stylesheet
#from trac.web.main import IRequestHandler
#from trac.util import escape, Markup
#from trac.util.html import html

class YumlPreprocessorSystem(Component):
    implements (IEnvironmentSetupParticipant,  ITemplateProvider)
    
    # IEnvironmentSetupParticipant methods    
    def environment_created(self):
        self.found_db_version = 0
        self.upgrade_environment(self.env.get_db_cnx())
        
    def environment_needs_upgrade(self, db):
        cursor = db.cursor()
        cursor.execute("SELECT value FROM system WHERE name=%s", (db_default.name,))
        value = cursor.fetchone()

        if not value:
            self.found_db_version = 0
            self.log.debug("YumlPreprocessorSystem.environment_needs_upgrade: No cache databade found!")
            return True
        else:
            self.found_db_version = int(value[0])
            self.log.debug("YumlPreprocessorSystem.environment_needs_upgrade: Found database version %r. Needed Version is %r!",self.found_db_version,db_default.version)
            if self.found_db_version < db_default.version:
                return True        
                    
        return False
        
    def upgrade_environment(self, db):
        db_manager, _ = DatabaseManager(self.env)._get_connector()
        cursor = db.cursor()
        old_data = {}
                
        if not self.found_db_version:
            self.log.debug("YumlPreprocessorSystem.upgrade_environment: Insert new table with version %r.",db_default.version)
            cursor.execute("INSERT INTO system (name, value) VALUES (%s, %s)",(db_default.name, db_default.version))
        else:
            self.log.debug("YumlPreprocessorSystem.upgrade_environment: Upgrade table to version %r.",db_default.version)
            cursor.execute("UPDATE system SET value=%s WHERE name=%s",(db_default.version, db_default.name))
        
            for tbl in db_default.tables:
                try:
                    cursor.execute('SELECT * FROM %s'%tbl.name)
                    old_data[tbl.name] = ([d[0] for d in cursor.description], cursor.fetchall())
                    cursor.execute('DROP TABLE %s'%tbl.name)
                except Exception, e:
                    if 'OperationalError' not in e.__class__.__name__:
                        raise e # If it is an OperationalError, just move on to the next table
       
        for tbl in db_default.tables:
            for sql in db_manager.to_sql(tbl):
                cursor.execute(sql)
        
            # Try to reinsert any old data
            if tbl.name in old_data:
                data = old_data[tbl.name]
                sql = 'INSERT INTO %s (%s) VALUES (%s)' % \
                      (tbl.name, ','.join(data[0]), ','.join(['%s'] * len(data[0])))
                for row in data[1]:
                    try:
                        cursor.execute(sql, row)
                    except Exception, e:
                        if 'OperationalError' not in e.__class__.__name__:
                            raise e
    # ITemplateProvider methods
    def get_templates_dirs(self):
        """Return a list of directories containing the provided ClearSilver templates.
        """
        
        from pkg_resources import resource_filename
        return [resource_filename(__name__, 'templates')]

    def get_htdocs_dirs(self):
        """Return a list of directories with static resources (such as style
        sheets, images, etc.)

        Each item in the list must be a `(prefix, abspath)` tuple. The
        `prefix` part defines the path in the URL that requests to these
        resources are prefixed with.

        The `abspath` is the absolute path to the directory containing the
        resources on the local file system.
        """
        from pkg_resources import resource_filename
        return [('yp', resource_filename(__name__, 'htdocs'))]
    
